Leetcode 30天高效刷数据结构和算法 Day1 两数之和 —— 无序数组

Leetcode 30天高效刷数据结构和算法 Day1 两数之和 —— 无序数组_第1张图片
在这里插入图片描述

两数之和 —— 无序数组

给定一个整数数组 nums 和一个整数目标值 target,请你在该数组中找出 和为目标值 target 的那 两个 整数,并返回它们的数组下标。

你可以假设每种输入只会对应一个答案。但是,数组中同一个元素在答案里不能重复出现。

你可以按任意顺序返回答案。

示例 1:

输入:nums = [2,7,11,15], target = 9
输出:[0,1]
解释:因为 nums[0] + nums[1] == 9 ,返回 [0, 1] 。
示例 2:

输入:nums = [3,2,4], target = 6
输出:[1,2]
示例 3:

输入:nums = [3,3], target = 6
输出:[0,1]

两数之和问题解法

1. 暴力解法

代码

public static int[] twoSum(int[] nums, int target) {
    for(int i=1;i<nums.length;i++){
        for (int j=0; j<i; j++) {
            if(nums[i]+nums[j]==target){
                return new int[]{j,i};
            }
        }
    }
    return new int[0];
}

时间复杂度

O(n²)

2. 优化

优化思路

如果要同时判断符合条件的i和j是否存在数组中,则必定需要使用双层循环,时间复杂度为O(n²)+。
因此我们可以考虑将另一个参数表示为target-x(x为第一个参数)。
为了判断是否存在,考虑使用哈希表,来存储数组元素:元素下标,Map就是典型的空间换时间
此时我们最多遍历一次数组,因此优化后的时间复杂度为O(n)

代码

public static int[] twoSum1(int[] nums, int target) {
	Map<Integer,Integer> map = new HashMap<>();
	for (int i = 0; i < nums.length; i++) {
		if(map.containsKey(target-nums[i])){
			return new int[]{map.get(target-nums[i]),i};
		}
		map.put(nums[i],i);
	}
	return new int[]{0};
}

时间复杂度

O(n)

你可能感兴趣的:(Leetcode,30天高效数据结构和算法,算法,leetcode,数据结构)